<?php

echo '<pre>';

try {
    $cwdir = dirname(__FILE__);
    $sysTmpDir = sys_get_temp_dir();


    $ini = parse_ini_file("configuration.ini", true);
    define('DB_HOST', $ini['database']['host']);
    define('DB_USER', $ini['database']['user']);
    define('DB_PASW', $ini['database']['pasw']);
    //print_r($ini);

    $db = new ImprovedDatabase();
    $db->openDB(DB_HOST, DB_USER, DB_PASW);

    $query = "SHOW DATABASES";
    $db->setQuery($query);
    $rows = $db->loadObjectList();
    
    $rows = array_slice($rows, 0, 6);
    
    $ts = date("Ymd");
    
    $savepath = $ini['mysqldump']['savepath'];
    $binary = $ini['mysqldump']['binary'];
    $zipcmd = $ini['mysqldump']['zipcmd'];

    foreach ($rows as $row) {
        if (is_array($ini['database']['exclude_dbs']) && in_array($row->Database, $ini['database']['exclude_dbs']))
            continue;
        
        
        $dumpFile = $sysTmpDir.$ts."_$row->Database" . ".sql";
        $compressedFile = $savepath."/".$ts."_$row->Database" . ".sql.7z";
        
        echo "> DUMPING DATABASE $row->Database TO $dumpFile" . PHP_EOL;
        $cmd_params = " --opt --host " . DB_HOST . " --force --user " . DB_USER . " --password=\"" . DB_PASW . "\" --database $row->Database > $dumpFile";
        
        $cmd = $binary . $cmd_params;
        //echo $cmd;
        echo PHP_EOL;
        $last_line = exec($cmd, $retval);       
        echo PHP_EOL;
        
        echo "> Creating compressed file => $compressedFile".PHP_EOL;
        $compressCmd = "$zipcmd $compressedFile $dumpFile";
        exec($compressCmd, $retval);  
        //echo $compressCmd;
        echo PHP_EOL;
        
        echo "> Deleting temp file => $dumpFile".PHP_EOL;
        
        unlink($dumpFile);
        
        echo '> DONE!'.PHP_EOL;
    }
} catch (Exception $e) {
    echo $e->getMessage();
}



echo '</pre>';

class ImprovedDatabase {

    var $classname = "database";

    /** @var string Internal variable to hold the query sql */
    var $_sql = '';
    var $_errorNum = 0;

    /** @var string Internal variable to hold the database error message */
    var $_errorMsg = '';

    /** @var string Internal variable to hold the prefix used on all database tables */
    var $_table_prefix = '';

    /** @var Internal variable to hold the connector resource */
    var $_resource = '';

    /** @var Internal variable to hold the last query cursor */
    var $_cursor = null;

    /** @var boolean Debug option */
    var $_dbname = null;
    var $_has_switched = false;

    function openDB($hostname, $username, $password, $dbName='') {
        $this->_resource = mysqli_connect($hostname, $username, $password) OR DIE("Unable to connect to database");

        if ($dbName != '')
            @mysqli_select_db("$dbName") or die("Unable to select database");

        $this->_dbname = $dbName;
    }

    function closeDB() {
        mysqli_close($this->_resource);
    }

    function setQuery($sql) {
        $this->_sql = $sql;
    }

    function getCFG($fieldName) {
        $q = "select value from configuration where field='$fieldName'";
        $this->setQuery($q);
        return $this->loadResult();
    }

    function changeDatabase($dbName='shared') {
        $this->_has_switched = true;
        @mysqli_select_db("$dbName") or die("Unable to select database $dbName");
    }

    function defaultDB() {
        $this->_has_switched = false;
        @mysqli_select_db($this->_dbname) or die("Unable to select database $this->_dbname");
    }

    function query() {

        $this->_cursor = mysqli_query($this->_resource, $this->_sql);
        if (!$this->_cursor) {
            $this->_errorNum = mysqli_errno($this->_resource);
            $this->_errorMsg = mysqli_error($this->_resource);
            return false;
        }
        return $this->_cursor;
    }

    function preparedStatementInsert($table, $otherField='', $otherValue='') {
        $query = "insert into $table(";
        $post_query = ") values(";
        $keys = array();
        $values = array();

        $array_itersection = array("option" => 0, "task" => 0, "maxlist" => 0, "maxlist_gal" => 0, "id" => 0, "fsize" => 0, "ffont" => 0, "fcolor" => 0);

        $search_array = array_diff($_POST, $array_itersection);

        foreach ($search_array as $data) {
            $key = key($search_array);
            if (!($key == "option" || $key == "task")) {
                $query.=key($search_array) . ",";
                $post_query.="'$data',";
            }
            next($search_array);
        }

        $query .=$otherField . $post_query . $otherValue . ")";
        $query = str_replace(",)", ")", $query);
        return $query;
    }

    function UPD($table, $insert_id, $field, $method='P') {


        switch ($method) {
            case 'G':
                $value = $_GET[$field];
                break;

            case 'R':
                $value = $_REQUEST[$field];
                break;

            case 'S':
                $value = $_SESSION[$field];
                break;

            case 'C':
                $value = $_COOKIE[$field];
                break;

            default:
                $value = $_POST[$field];
                break;
        }

        if (!isset($value))
            return "";
        $value = trim($value);

        $query = "update $table set $field='$value' where id=$insert_id ;";
        return $query;
    }

    function pInsert($table, $array) {
        $user_id = $_SESSION['auth_id'];
        $q = "insert into $table(%s) values(%s);";

        $fields = "";
        $values = "";
        for ($i = 0; $i < count($array); $i++) {
            $v = $_REQUEST[$array[$i]];
            if (isset($v)) {
                $fields .= "," . $array[$i];
                $values .= ",'" . trim($v) . "'";
            }
        }
        $ts = mosGetDate();
        $fields = "cuser,muser,cdate,mdate" . $fields;
        $values = "'$user_id','$user_id','$ts','$ts'" . $values;

        return sprintf($q, $fields, $values);
    }

    function pUpdate($table, $array) {
        $user_id = $_SESSION['auth_id'];
        $id = $_POST['id'];
        $q = "update $table set %s where id=$id;";


        $values = "";
        for ($i = 0; $i < count($array); $i++) {
            $v = $_REQUEST[$array[$i]];
            if (isset($v)) {
                $values .= "," . $array[$i] . "='" . trim($v) . "'";
            }
        }
        $ts = mosGetDate();
        $values = "muser='$user_id',mdate='$ts'" . $values;


        return sprintf($q, $values);
    }

    function preparedStatementUpdate($table, $end, $last_field, $mdate=false) {
        $query = "update $table set ";

        $array_itersection = array("option" => 0, "task" => 0, "maxlist" => 0, "maxlist_gal" => 0, "id" => 0, "fsize" => 0, "ffont" => 0, "fcolor" => 0);

        $search_array = array_diff($_POST, $array_itersection);

        foreach ($search_array as $data) {
            $key = key($search_array);

            $query.=key($search_array) . "='$data',";
            if ($key == $last_field)
                break;

            next($search_array);
        }

        if ($mdate)
            $query.="mdate='" . date("Y-m-d H:i:s") . "',";

        $query .= $end;
        $query = str_replace(", where", " where", $query);
        return $query;
    }

    /**
     * @return int The number of rows returned from the most recent query.
     */
    function getNumRows($cur=null) {
        return mysqli_num_rows($cur ? $cur : $this->_cursor );
    }

    function getAffectedRows() {
        return mysqli_affected_rows();
    }

    /**
     * This method loads the first field of the first row returned by the query.
     *
     * @return The value returned in the query or null if the query failed.
     */
    function loadResult() {
        if (!($cur = $this->query())) {
            return null;
        }
        $ret = null;
        if ($row = mysqli_fetch_row($cur)) {
            $ret = $row[0];
        }
        mysqli_free_result($cur);
        return $ret;
    }

    /**
     * Load an array of single field results into an array
     */
    function loadResultArray($numinarray = 0) {
        if (!($cur = $this->query())) {
            return null;
        }
        $array = array();
        while ($row = mysqli_fetch_row($cur)) {
            $array[] = $row[$numinarray];
        }
        mysqli_free_result($cur);
        return $array;
    }

    function mosBindArrayToObject($array, &$obj, $ignore='', $prefix=NULL, $checkSlashes=true) {
        if (!is_array($array) || !is_object($obj)) {
            return (false);
        }
    }

    /**
     * Load a assoc list of database rows
     * @param string The field name of a primary key
     * @return array If <var>key</var> is empty as sequential list of returned records.
     */
    function loadAssocList($key='') {
        if (!($cur = $this->query())) {
            return null;
        }
        $array = array();
        while ($row = mysqli_fetch_assoc($cur)) {
            if ($key) {
                $array[$row->$key] = $row;
            } else {
                $array[] = $row;
            }
        }
        mysqli_free_result($cur);
        return $array;
    }

    /**
     * This global function loads the first row of a query into an object
     *
     * If an object is passed to this function, the returned row is bound to the existing elements of <var>object</var>.
     * If <var>object</var> has a value of null, then all of the returned query fields returned in the object.
     * @param string The SQL query
     * @param object The address of variable
     */
    function loadObject(&$object) {
        if ($object != null) {
            if (!($cur = $this->query())) {
                return false;
            }
            /* if ($array = mysql_fetch_assoc( $cur )) {
              mysql_free_result( $cur );
              mosBindArrayToObject( $array, $object, null, null, false );
              return true;
              } else {
              return false;
              } */
        } else {
            if ($cur = $this->query()) {
                if ($object = mysqli_fetch_object($cur)) {
                    mysqli_free_result($cur);
                    return true;
                } else {
                    $object = null;
                    return false;
                }
            } else {
                return false;
            }
        }
    }

    /**
     * Load a list of database objects
     * @param string The field name of a primary key
     * @return array If <var>key</var> is empty as sequential list of returned records.
     * If <var>key</var> is not empty then the returned array is indexed by the value
     * the database key.  Returns <var>null</var> if the query fails.
     */
    function loadObjectList($key='') {
        if (!($cur = $this->query())) {
            return null;
        }
        $array = array();
        while ($row = mysqli_fetch_object($cur)) {
            if ($key) {
                $array[$row->$key] = $row;
            } else {
                $array[] = $row;
            }
        }
        mysqli_free_result($cur);
        return $array;
    }

    /**
     * @return The first row of the query.
     */
    function loadRow() {
        if (!($cur = $this->query())) {
            return null;
        }
        $ret = null;
        if ($row = mysqli_fetch_row($cur)) {
            $ret = $row;
        }
        mysqli_free_result($cur);
        return $ret;
    }

    /**
     * Load a list of database rows (numeric column indexing)
     * @param string The field name of a primary key
     * @return array If <var>key</var> is empty as sequential list of returned records.
     * If <var>key</var> is not empty then the returned array is indexed by the value
     * the database key.  Returns <var>null</var> if the query fails.
     */
    function loadRowList($key='') {
        if (!($cur = $this->query())) {
            return null;
        }
        $array = array();
        while ($row = mysqli_fetch_array($cur)) {
            if ($key) {
                $array[$row[$key]] = $row;
            } else {
                $array[] = $row;
            }
        }
        mysqli_free_result($cur);
        return $array;
    }

}

?>
